--- old/usr/src/tools/smatch/src/check_buffer_too_small_for_struct.c	Mon Aug  5 08:37:54 2019
+++ new/usr/src/tools/smatch/src/check_buffer_too_small_for_struct.c	Mon Aug  5 08:37:54 2019
@@ -26,6 +26,8 @@
 	struct symbol *left_type, *right_type;
 	struct expression *size_expr;
 	sval_t min_size;
+	int limit_type;
+	int bytes;
 
 	left_type = get_type(expr->left);
 	if (!left_type || left_type->type != SYM_PTR)
@@ -43,9 +45,15 @@
 	if (right_type != &void_ctype && type_bits(right_type) != 8)
 		return;
 
-	size_expr = get_size_variable(expr->right);
+	bytes = get_array_size_bytes(expr->right);
+	if (bytes >= type_bytes(left_type))
+		return;
+
+	size_expr = get_size_variable(expr->right, &limit_type);
 	if (!size_expr)
 		return;
+	if (limit_type != ELEM_COUNT)
+		return;
 
 	get_absolute_min(size_expr, &min_size);
 	if (min_size.value >= type_bytes(left_type))
@@ -62,6 +70,7 @@
 	char *name;
 	struct expression *size_expr;
 	sval_t min_size;
+	int limit_type;
 
 	if (expr->type != EXPR_PREOP)
 		return;
@@ -79,9 +88,11 @@
 		return;
 
 	right = get_assigned_expr(expr);
-	size_expr = get_size_variable(right);
+	size_expr = get_size_variable(right, &limit_type);
 	if (!size_expr)
 		return;
+	if (limit_type != ELEM_COUNT)
+		return;
 
 	get_absolute_min(size_expr, &min_size);
 	if (min_size.value >= type_bytes(left_type))
